/* The following are from cg.h */
	  CGcontext cgCreateContext(void);
	       void cgDestroyContext(CGcontext);
	     CGbool cgIsContext(CGcontext);
	const char *cgGetLastListing(CGcontext);

	  CGprogram cgCreateProgram(CGcontext ctx,
                                    CGenum program_type,
                                    const char *program,
                                    CGprofile profile,
                                    const char *entry,
                                    const char **args);
	  CGprogram cgCreateProgramFromFile(CGcontext ctx,
                                            CGenum program_type,
                                            const char *program_file,
                                            CGprofile profile,
                                            const char *entry,
                                            const char **args);
	  CGprogram cgCopyProgram(CGprogram program);
	       void cgDestroyProgram(CGprogram program);

	  CGprogram cgGetFirstProgram(CGcontext ctx);
	  CGprogram cgGetNextProgram(CGprogram current);
	  CGcontext cgGetProgramContext(CGprogram prog);
	     CGbool cgIsProgram(CGprogram program);

	       void cgCompileProgram(CGprogram program);
	     CGbool cgIsProgramCompiled(CGprogram program);
	const char *cgGetProgramString(CGprogram prog, CGenum pname);
	  CGprofile cgGetProgramProfile(CGprogram prog);

	CGparameter cgGetNamedParameter(CGprogram prog, const char *name);
	CGparameter cgGetFirstParameter(CGprogram prog, CGenum name_space);
	CGparameter cgGetNextParameter(CGparameter current);
	CGparameter cgGetFirstLeafParameter(CGprogram prog, CGenum name_space);
	CGparameter cgGetNextLeafParameter(CGparameter current);


	CGparameter cgGetFirstStructParameter(CGparameter param);
	CGparameter cgGetFirstDependentParameter(CGparameter param);

	CGparameter cgGetArrayParameter(CGparameter aparam, int index);
		int cgGetArrayDimension(CGparameter param);
		int cgGetArraySize(CGparameter param, int dimension);

	  CGprogram cgGetParameterProgram(CGparameter prog);
	     CGbool cgIsParameter(CGparameter param);
	const char *cgGetParameterName(CGparameter param);
	     CGtype cgGetParameterType(CGparameter param);
	const char *cgGetParameterSemantic(CGparameter param);
	 CGresource cgGetParameterResource(CGparameter param);
	 CGresource cgGetParameterBaseResource(CGparameter param);
      unsigned long cgGetParameterResourceIndex(CGparameter param);
	     CGenum cgGetParameterVariability(CGparameter param);
	     CGenum cgGetParameterDirection(CGparameter param);
	     CGbool cgIsParameterReferenced(CGparameter param);
      const double *cgGetParameterValues(CGparameter param,
                                         CGenum value_type,
                                         int *nvalues);
		int cgGetParameterOrdinalNumber(CGparameter param);


	const char *cgGetTypeString(CGtype type);
	     CGtype cgGetType(const char *type_string);


	const char *cgGetResourceString(CGresource resource);
	 CGresource cgGetResource(const char *resource_string);


	const char *cgGetProfileString(CGprofile profile);
	  CGprofile cgGetProfile(const char *profile_string);


	    CGerror cgGetError(void);
	const char *cgGetErrorString(CGerror error);

/* The following are from cgGL.h */
	     CGbool cgGLIsProfileSupported(CGprofile profile);

	       void cgGLEnableProfile(CGprofile profile);
	       void cgGLDisableProfile(CGprofile profile);

	  CGprofile cgGLGetLatestProfile(CGGLenum profile_type);
	       void cgGLSetOptimalOptions(CGprofile profile);

	       void cgGLLoadProgram(CGprogram program);
	       void cgGLBindProgram(CGprogram program);

	       void cgGLSetParameter1f(CGparameter param, float x);
	       void cgGLSetParameter2f(CGparameter param, float x, float y);
	       void cgGLSetParameter3f(CGparameter param, float x, float y,
                                       float z);
	       void cgGLSetParameter4f(CGparameter param, float x, float y, 
				       float z, float w);

	       void cgGLSetParameter1fv(CGparameter param, const float *v);
	       void cgGLSetParameter2fv(CGparameter param, const float *v);
	       void cgGLSetParameter3fv(CGparameter param, const float *v);
	       void cgGLSetParameter4fv(CGparameter param, const float *v);

	       void cgGLSetParameter1d(CGparameter param, double x);
	       void cgGLSetParameter2d(CGparameter param, double x,
                                       double y);
	       void cgGLSetParameter3d(CGparameter param, double x,
                                       double y, double z);
	       void cgGLSetParameter4d(CGparameter param, double x,
                                       double y, double z, double w);

	       void cgGLSetParameter1dv(CGparameter param, const double *v);
	       void cgGLSetParameter2dv(CGparameter param, const double *v);
	       void cgGLSetParameter3dv(CGparameter param, const double *v);
	       void cgGLSetParameter4dv(CGparameter param, const double *v);

	       void cgGLGetParameter1f(CGparameter param, float *v);
	       void cgGLGetParameter2f(CGparameter param, float *v);
	       void cgGLGetParameter3f(CGparameter param, float *v);
	       void cgGLGetParameter4f(CGparameter param, float *v);

	       void cgGLGetParameter1d(CGparameter param, double *v);
	       void cgGLGetParameter2d(CGparameter param, double *v);
	       void cgGLGetParameter3d(CGparameter param, double *v);
	       void cgGLGetParameter4d(CGparameter param, double *v);


	       void cgGLSetParameterArray1f(CGparameter param, long offset,
                                            long nelements, const float *v);
	       void cgGLSetParameterArray2f(CGparameter param, long offset,
                                            long nelements, const float *v);
	       void cgGLSetParameterArray3f(CGparameter param, long offset,
                                            long nelements, const float *v);
	       void cgGLSetParameterArray4f(CGparameter param, long offset,
                                            long nelements, const float *v);

	       void cgGLSetParameterArray1d(CGparameter param, long offset,
                                            long nelements, const double *v);
	       void cgGLSetParameterArray2d(CGparameter param, long offset,
                                            long nelements, const double *v);
	       void cgGLSetParameterArray3d(CGparameter param, long offset,
                                            long nelements, const double *v);
	       void cgGLSetParameterArray4d(CGparameter param, long offset,
                                            long nelements, const double *v);

	       void cgGLGetParameterArray1f(CGparameter param, long offset,
                                            long nelements, float *v);
	       void cgGLGetParameterArray2f(CGparameter param, long offset,
                                            long nelements, float *v);
	       void cgGLGetParameterArray3f(CGparameter param, long offset,
                                            long nelements, float *v);
	       void cgGLGetParameterArray4f(CGparameter param, long offset,
                                            long nelements, float *v);

	       void cgGLGetParameterArray1d(CGparameter param, long offset,
                                            long nelements, double *v);
	       void cgGLGetParameterArray2d(CGparameter param, long offset,
                                            long nelements, double *v);
	       void cgGLGetParameterArray3d(CGparameter param, long offset,
                                            long nelements, double *v);
	       void cgGLGetParameterArray4d(CGparameter param, long offset,
                                            long nelements, double *v);

	       void cgGLSetParameterPointer(CGparameter param, GLint fsize,
                                            GLenum type, GLsizei stride,
                                            GLvoid *pointer);

	       void cgGLEnableClientState(CGparameter param);
	       void cgGLDisableClientState(CGparameter param);

	       void cgGLSetMatrixParameterdr(CGparameter param, const double *matrix);
	       void cgGLSetMatrixParameterfr(CGparameter param, const float *matrix);
	       void cgGLSetMatrixParameterdc(CGparameter param, const double *matrix);
	       void cgGLSetMatrixParameterfc(CGparameter param, const float *matrix);

	       void cgGLGetMatrixParameterdr(CGparameter param, double *matrix);
	       void cgGLGetMatrixParameterfr(CGparameter param, float *matrix);
	       void cgGLGetMatrixParameterdc(CGparameter param, double *matrix);
	       void cgGLGetMatrixParameterfc(CGparameter param, float *matrix);

	       void cgGLSetStateMatrixParameter(CGparameter param,
                                                CGGLenum matrix, CGGLenum transform);


	       void cgGLSetMatrixParameterArrayfc(CGparameter param, long offset,
                                                  long nelements, const float *matrices);
	       void cgGLSetMatrixParameterArrayfr(CGparameter param, long offset,
                                                  long nelements, const float *matrices);

	       void cgGLSetMatrixParameterArraydc(CGparameter param, long offset,
                                                  long nelements, const double *matrices);
	       void cgGLSetMatrixParameterArraydr(CGparameter param, long offset,
                                                  long nelements, const double *matrices);

	       void cgGLGetMatrixParameterArrayfc(CGparameter param, long offset,
                                                  long nelements, float *matrices);
	       void cgGLGetMatrixParameterArrayfr(CGparameter param, long offset,
                                                  long nelements, float *matrices);

	       void cgGLGetMatrixParameterArraydc(CGparameter param, long offset,
                                                  long nelements, double *matrices);
	       void cgGLGetMatrixParameterArraydr(CGparameter param, long offset,
                                                  long nelements, double *matrices);

	       void cgGLSetTextureParameter(CGparameter param, GLuint texobj);
	     GLuint cgGLGetTextureParameter(CGparameter param);
	       void cgGLEnableTextureParameter(CGparameter param);
	       void cgGLDisableTextureParameter(CGparameter param);
	     GLenum cgGLGetTextureEnum(CGparameter param);

